/*
 * LED Driver Demo Application
 * Copyright (c) 2013-2014 China JiLiang University
 * All Rights Reserved.
 */

/*!
 * @file        main.c
 * @version     1.0
 * @author      Cangcang Zhou
 * @date        2013-10-10
 * @brief       DC_DC_Boost_Stellaris 1PWMź
 * PWM			PB6  ֵͨPWMռձ ռձȵڷΧ 5 ~ 95 %
 * PE0			ʹPC4ռձ
 * ADC		PE2
 */

#ifndef  PART_LM4F120H5QR
#define  PART_LM4F120H5QR
#endif


#include <stdbool.h>
#include <stdint.h>
#include "inc/hw_types.h"
#include "driverlib/rom.h"
#include "driverlib/adc.h"
#include "driverlib/sysctl.h"
#include "driverlib/pwm.h"
#include "driverlib/gpio.h"
#include "driverlib/timer.h"
#include "driverlib/pin_map.h"
#include "inc/hw_ints.h"

#include "inc/hw_memmap.h"
#include "LCDDriver.h"



int main(void)
{



	// ʹLCD
	LCD_Enable();

	// ʼLCD
	LCD_Init();

	// 
	LCD_ScreenClr();

	LCD_Draw_Chinese(1, 0, 0, LCD_DRAW_NORMAL);			// 
	LCD_Draw_Chinese(3, 0, 16, LCD_DRAW_NORMAL);		// 
	LCD_Draw_Char(':', 0, 30, LCD_DRAW_NORMAL);			// :
	LCD_Draw_Char('m', 0, 100, LCD_DRAW_NORMAL);		// m
	LCD_Draw_Char('A', 0, 111, LCD_DRAW_NORMAL);		// A


	unsigned long ulADC0_Value[1];
	unsigned long ulADC0_Value1[1];
		   SysCtlClockSet(SYSCTL_SYSDIV_10|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|
	                    SYSCTL_OSC_MAIN);				//ϵͳʱ

	       SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
		   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);

		   GPIOPinTypeADC(GPIO_PORTE_BASE,GPIO_PIN_0);//ѡPE0 PE2ΪADC
		   GPIOPinTypeADC(GPIO_PORTE_BASE,GPIO_PIN_2);

		   ADCSequenceConfigure(ADC0_BASE,3,ADC_TRIGGER_PROCESSOR,0);//PE0 PE2ADCͨ
		   ADCSequenceConfigure(ADC0_BASE,1,ADC_TRIGGER_PROCESSOR,0);

		   ADCSequenceStepConfigure(ADC0_BASE,3,0,ADC_CTL_CH3 | ADC_CTL_IE |
		                                          ADC_CTL_END);
		   ADCSequenceStepConfigure(ADC0_BASE,1,0,ADC_CTL_CH1 | ADC_CTL_IE |
		   		                                          ADC_CTL_END);
		   ADCSequenceEnable(ADC0_BASE,3);
		   ADCSequenceEnable(ADC0_BASE,1);

		   ADCIntClear(ADC0_BASE,3);
		   ADCIntClear(ADC0_BASE,1);

		   unsigned long ulPeriod, dutyCycle;

		       // 40 MHz system clock
		       SysCtlClockSet(SYSCTL_SYSDIV_5|SYSCTL_USE_PLL|
		           SYSCTL_XTAL_16MHZ|SYSCTL_OSC_MAIN);

		       ulPeriod = 3300;
		       dutyCycle = 250;

		       // Turn off LEDs
		       SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
		       GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3);
		       GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3, 0);

		       // Configure PB6 as T0CCP0
		       SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
		       GPIOPinConfigure(GPIO_PB6_T0CCP0);
		       GPIOPinTypeTimer(GPIO_PORTB_BASE, GPIO_PIN_6);

		       // Configure timer
		       SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
		       TimerConfigure(TIMER0_BASE, TIMER_CFG_SPLIT_PAIR|TIMER_CFG_A_PWM);
		       TimerLoadSet(TIMER0_BASE, TIMER_A, ulPeriod -1);
		       TimerMatchSet(TIMER0_BASE, TIMER_A, dutyCycle); // PWM
		       TimerEnable(TIMER0_BASE, TIMER_A);
		   while(1)
			 {
	               ADCProcessorTrigger(ADC0_BASE,3);
				   while(!ADCIntStatus(ADC0_BASE,3,false))
					 {

					 }
					 ADCSequenceDataGet(ADC0_BASE,3,ulADC0_Value);
					 unsigned long sample1 = ulADC0_Value[0] * 3300  / 4096 ;
					 if(sample1 <165) sample1 = 165;
					 if(sample1 >3135) sample1 = 3135;
					 dutyCycle = sample1;
					 sample1 = 100-sample1/33;
					 TimerMatchSet(TIMER0_BASE, TIMER_A, dutyCycle);
					 unsigned char number = '0';
					 int i = 0 ;
					 unsigned char data[4] = {0};
					 data[0] = sample1 / 1000;
					 data[1] = (sample1 / 100) % 10;
					 data[2] = (sample1 / 10) % 10;
					 data[3] = (sample1 / 1) % 10;
					 for(i = 2; i < 4; ++i)
					{
						LCD_Draw_Char(number + data[i], 1, 50 + 10 * i, LCD_DRAW_NORMAL);
						LCD_Draw_Char('%', 1, 50+10*4, LCD_DRAW_NORMAL);
					}

			         ADCProcessorTrigger(ADC0_BASE,1);
			 	     while(!ADCIntStatus(ADC0_BASE,1,false))
					  {

					  }
					 ADCSequenceDataGet(ADC0_BASE,1,ulADC0_Value1);
					 unsigned long sample2 = ulADC0_Value1[0] * 1000 / 4096 ;
					 unsigned char number1 = '0';
					 int j = 0 ;
					 unsigned char data1[4] = {0};
					 data1[0] = sample2 / 1000;
					 data1[1] = (sample2 / 100) % 10;
					 data1[2] = (sample2 / 10) % 10;
					 data1[3] = (sample2 / 1) % 10;
					 for(j = 0; j < 4; ++j)
						{
						LCD_Draw_Char(number1 + data1[j], 0, 50 + 10 * j, LCD_DRAW_NORMAL);
						}

					 SysCtlDelay(SysCtlClockGet()/12);
	         }


}
//---------------------------------------------------------------------------
